<!--
<error-code-edit
  :editRow="editRow"
  :showDialog="showDialog"
  @hideDialog="hideDialog">
</error-code-edit>

import errorCodeEdit from '@/components/error/error-code-edit.vue'
 -->
<template>
  <div v-show="customDialog">
    <el-dialog
      class="edit-dialog"
      title="编辑"
      :visible.sync="customDialog"
      width="600px"
      :before-close="handleClose">
      <div class="edit-dialog-body">
        <el-form
          ref="errorCodeForm"
          :model="formData"
          label-width="116px"
          :rules="rules">
          <el-form-item
            label="错误码:"
            prop="errorCode">
            <el-input
              v-model="formData.errorCode"
              :disabled="formData.errorSettingId ? true : false" />
          </el-form-item>
          <el-form-item
            label="错误消息:"
            prop="errorCode">
            <el-input v-model="formData.errorInfo" />
          </el-form-item>
          <el-form-item
            v-if="formData.interfaceName"
            label="使用的接口名称:">
            {{ formData.interfaceName }}
          </el-form-item>
          <el-form-item
            v-if="formData.projectAndGroup"
            label="使用的项目分组:">
            {{ formData.projectAndGroup }}
          </el-form-item>
        </el-form>
      </div>
      <div
        slot="footer"
        class="dialog-footer"
        style="padding-bottom: 10px;">
        <el-button @click="customCancel">
          取 消
        </el-button>
        <el-button
          type="primary"
          @click="customConfirm('errorCodeForm')">
          保 存
        </el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { postRequest } from '@/api/api';
import showMsg from '@/assets/js/showmsg';
import errMsg from '@/assets/js/error';
export default {
  name: 'ErrorCodeEdit',
  props: {
    showDialog: {
      type: Boolean,
      default: false
    },
    editRow: {
      type: Object,
      default() {
        return {
          errorSettingId: '',
          interfaceName: '',
          projectAndGroup: '',
          errorCode: '',
          errorInfo: ''
        };
      }
    }
  },
  data() {
    return {
      customDialog: false, // 弹框显示
      formData: {
        errorSettingId: '',
        interfaceName: '',
        projectAndGroup: '',
        errorCode: '',
        errorInfo: ''
      },
      rules: {
        errorCode: [ { required: true, message: '请输入错误码', trigger: 'blur' } ],
        errorInfo: [ { required: true, message: '请输入错误消息', trigger: 'blur' } ]
      }
    };
  },

  /* 接收数据 */
  mounted() {
    const that = this;
    that.customDialog = that.showDialog;
    if (Object.keys(that.editRow).length) {
      that.formData = JSON.parse(JSON.stringify(that.editRow));
    }
  },
  methods: {
    /**
     * @description: 关闭
     * @param {Function} done
     * @author: 无尘
     */
    handleClose(done) {
      const that = this;
      done();
      that.hideDialog();
    },

    /**
     * @description: 取消
     * @author: 无尘
     */
    customCancel() {
      const that = this;
      that.hideDialog();
    },

    hideDialog() {
      const that = this;
      that.customDialog = false;
      that.formData.errorCode = '';
      that.formData.errorInfo = '';
      that.$emit('hideDialog', '');
      /* that.$nextTick(() => {
        that.formData.classifyName = '';
      }); */
    },

    /**
     * @description: 确定
     * @param {String} formName
     * @author: 无尘
     */
    customConfirm(formName) {
      const that = this;
      that.formData.errorCode = that.formData.errorCode ? String(that.formData.errorCode).replace(/\s+/g, '') : '';
      that.formData.errorInfo = that.formData.errorInfo ? String(that.formData.errorInfo).replace(/\s+/g, '') : '';
      that.$refs[formName].validate(valid => {
        if (valid) {
          that.postEditData();
        } else {
          return false;
        }
      });
    },
    postEditData() {
      const that = this;
      let para = {
        errorSettingId: that.formData.errorSettingId,
        errorCode: that.formData.errorCode,
        errorInfo: that.formData.errorInfo
      };
      postRequest(that.editRow.errorSettingId ? '/gateway-manage/update-error-setting' : '/gateway-manage/create-error-setting', para)
        .then(res => {
          let resData = res.data;
          if (resData.code == '0000') {
            showMsg.showmsg('保存成功', 'success');
            that.setData();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     * @description: 提交数据
     * @author: 无尘
     */
    setData() {
      const that = this;
      that.$emit('hideDialog', that.formData);
      that.$nextTick(() => {
        that.formData.errorCode = '';
        that.formData.errorInfo = '';
      });
    }
  },
  watch: {
    showDialog: function(newData, oldData) {
      const that = this;
      that.customDialog = newData;
    },
    editRow: function(newData, oldData) {
      const that = this;
      if (Object.keys(newData).length) {
        that.formData = JSON.parse(JSON.stringify(newData));
      }
    }
  }
};
</script>

<style lang="less" scoped>
.edit-dialog {
  /deep/ .el-dialog__body {
    padding: 2px 55px 0 34px;
  }

  /deep/ .el-dialog__footer {
    border: none;
    padding-top: 3px;
  }

  &__title {
    width: 100%;
    height: 38px;
    padding: 12px 15px;
    -webkit-box-sizing: border-box;
    -moz-box-sizing: border-box;
    box-sizing: border-box;
    background: rgba(235, 238, 245, 1);
  }

  .el-alert--info {
    width: 400px;
    font-size: 14px;
    color: #606266;
    background: #e6f7ff;
    border: 1px solid rgba(145, 213, 255, 1);
  }
  .el-icon-info {
    width: 12px;
    font-size: 12px;
    color: #1890ff;
  }
  .el-form {
    margin-top: 40px;
  }
}
</style>
